[{
  Name: "Generic Sensor",
  Author: "Generoso Martello",
  Version: "2013-10-04",

  GroupName: '',
  IconImage: 'pages/control/widgets/homegenie/generic/images/power.png',
  StatusText: '',
  Description: '',
  Initialized: false,

  RenderView: function (cuid, module) {
    var container = $(cuid);
    var widget = container.find('[data-ui-field=widget]');
    //
    if (!this.Initialized) {
      this.Initialized = true;
      //
      // ui events handlers
      //
      // settings button
      widget.find('[data-ui-field=settings]').on('click', function () {
        HG.WebApp.Control.EditModule(module);
      });
    }

    widget.find('[data-ui-field=name]').html(module.Name);
    //
    var sensoricon = '';
    var sensorimgdata = '';
    var sensortxtdata = '';
    var infotext = '';
    var lastupdatetime = 0;

    var MeterState = '';
    var TotalGas = '';
    var TotalPeak = '';
    var TotalOffPeak = '';
    var TotalPeakPV = '';
    var TotalOffPeakPV = '';

    if(module.Properties != null) {
      for (p = 0; p < module.Properties.length; p++) {
        if (module.Properties[p].Name.indexOf('Meter.') == 0) {
          //var value = Math.round(module.Properties[p].Value.replace(',', '.') * 10) / 10;
          //if (isNaN(value)) value = module.Properties[p].Value;
          value = module.Properties[p].Value;
          //
          var displayname = module.Properties[p].Name;
          displayname = '<small>' + displayname.replace('Meter.', '') + '</small>';
          //
          var displayvalue = '<small>' + value + '</small>';
          //
          var updatetime = module.Properties[p].UpdateTime;
          if (typeof(updatetime) != 'undefined')
          {
            updatetime = updatetime.replace(' ', 'T'); // fix for IE and FF
            var d = new Date(updatetime);
            if (lastupdatetime < d) {
              lastupdatetime = d;
            }
          }
          //
          var imagesrc = '';
          //
          if (module.Properties[p].Name == 'Meter.State') {
            MeterState = module.Properties[p].Value;
            continue;
          }

          if (module.Properties[p].Name == 'Meter.TotalGas' && module.Properties[p].Value != '') {
            TotalGas = "<td>Gas</td><td>" + module.Properties[p].Value + " M<sup>3</sup></td>";
            continue;
          }

          if (module.Properties[p].Name == 'Meter.TotalPeak' && module.Properties[p].Value != '') {
            TotalPeak = "<td>Peak</td><td>" + module.Properties[p].Value + " kWh</td>";
            continue;
          }

          if (module.Properties[p].Name == 'Meter.TotalOffPeak' && module.Properties[p].Value != '') {
            TotalOffPeak = "<td>Off peak</td><td>" + module.Properties[p].Value + " kWh</td>";
            continue;
          }
          
          if (module.Properties[p].Name == 'Meter.TotalPeakPV' && module.Properties[p].Value != '') {
            TotalPeakPV = "<td>Peak PV</td><td>" + module.Properties[p].Value + " kWh</td>";
            continue;
          }

          if (module.Properties[p].Name == 'Meter.TotalOffPeakPV' && module.Properties[p].Value != '') {
            TotalOffPeakPV = "<td>Off peak PV</td><td>" + module.Properties[p].Value + " kWh</td>";
            continue;
          }

          if (module.Properties[p].Name == 'Meter.Watts') {
            sensortxtdata = '<span class="hg-indicator-energy" style="padding-left:0;width:20px;">&nbsp;</span>&nbsp;';
            sensortxtdata +=  module.Properties[p].Value;
          }

        }
      }
    }
    //
    var widgeticon = HG.WebApp.Utility.GetModulePropertyByName(module, 'Widget.DisplayIcon');
    if (widgeticon != null && widgeticon.Value != '') {
      this.IconImage = widgeticon.Value;
    }
    //
    widget.find('[data-ui-field=description]').html((module.Domain.substring(module.Domain.lastIndexOf('.') + 1))+' '+module.Address);
    //

    if (sensortxtdata != '') sensortxtdata = sensortxtdata;
    //if (lastupdatetime > 0) {
    this.UpdateTime = HG.WebApp.Utility.FormatDate(lastupdatetime) + ' ' + HG.WebApp.Utility.FormatDateTime(lastupdatetime);
    widget.find('[data-ui-field=status]').html('<span style="vertical-align:middle;font-size:13px">' + this.UpdateTime + '</span>&nbsp;&nbsp;' + infotext);

    widget.find('[data-ui-field=sensorstatus]').html(sensorimgdata + sensortxtdata);

    widget.find('[data-ui-field=meterstate]').html(MeterState);
    
    widget.find('[data-ui-field=TotalPeak]').html(TotalPeak);    
    widget.find('[data-ui-field=TotalOffPeak]').html(TotalOffPeak);
    widget.find('[data-ui-field=TotalGas]').html(TotalGas);

    widget.find('[data-ui-field=TotalPeakPV]').html(TotalPeakPV);    
    widget.find('[data-ui-field=TotalOffPeakPV]').html(TotalOffPeakPV);


    widget.find('[data-ui-field=icon]').attr('src', this.IconImage);
    //}
  }

}]